diff --git a/doc/guides/sample_app_ug/bbdev_app.rst b/doc/guides/sample_app_ug/bbdev_app.rst
index 405e706a46..ef12dca8e6 100644
--- a/doc/guides/sample_app_ug/bbdev_app.rst
+++ b/doc/guides/sample_app_ug/bbdev_app.rst
@@ -39,16 +39,7 @@ Compiling the Application
 
     .. code-block:: console
 
-        export RTE_SDK=/path/to/rte_sdk
-        cd ${RTE_SDK}/examples/bbdev_app
-
-#. Set the target (a default target is used if not specified). For example:
-
-    .. code-block:: console
-
-        export RTE_TARGET=x86_64-native-linux-gcc
-
-    See the *DPDK Getting Started Guide* for possible RTE_TARGET values.
+        cd dpdk/examples/bbdev_app
 
 #. Build the application:
 
diff --git a/doc/guides/sample_app_ug/compiling.rst b/doc/guides/sample_app_ug/compiling.rst
index 6f04743c82..c08cb63571 100644
--- a/doc/guides/sample_app_ug/compiling.rst
+++ b/doc/guides/sample_app_ug/compiling.rst
@@ -9,17 +9,11 @@ This section explains how to compile the DPDK sample applications.
 To compile all the sample applications
 --------------------------------------
 
-Set the path to DPDK source code if its not set:
-
-    .. code-block:: console
-
-        export RTE_SDK=/path/to/rte_sdk
-
 Go to DPDK source:
 
     .. code-block:: console
 
-        cd $RTE_SDK
+        cd dpdk
 
 Build DPDK:
 
@@ -32,15 +26,13 @@ Build the sample applications:
 
    .. code-block:: console
 
-       export RTE_TARGET=build
        make -C examples
 
-For other possible ``RTE_TARGET`` values and additional information on
-compiling see
+For additional information on compiling see
 :ref:`Compiling DPDK on Linux <linux_gsg_compiling_dpdk>` or
 :ref:`Compiling DPDK on FreeBSD <building_from_source>`.
-Applications are output to: ``$RTE_SDK/examples/app-dir/build`` or
-``$RTE_SDK/examples/app-dir/$RTE_TARGET``.
+Applications are output to: ``dpdk/examples/app-dir/build`` or
+``dpdk/examples/app-dir/{build_dir}``.
 
 
 In the example above the compiled application is written to the ``build`` subdirectory.
@@ -63,17 +55,11 @@ sets verbose output.
 To compile a single application
 -------------------------------
 
-Set the path to DPDK source code:
-
-    .. code-block:: console
-
-        export RTE_SDK=/path/to/rte_sdk
-
 Go to DPDK source:
 
     .. code-block:: console
 
-       cd $RTE_SDK
+       cd dpdk
 
 Build DPDK:
 
@@ -83,14 +69,13 @@ Build DPDK:
         make
 
 Go to the sample application directory. Unless otherwise specified the sample
-applications are located in ``$RTE_SDK/examples/``.
+applications are located in ``dpdk/examples/``.
 
 
 Build the application:
 
     .. code-block:: console
 
-        export RTE_TARGET=build
         make
 
 To cross compile the sample application(s)
@@ -101,8 +86,6 @@ In example of AARCH64 cross compiling:
 
     .. code-block:: console
 
-        export RTE_TARGET=build
-        export RTE_SDK=/path/to/rte_sdk
         make -C examples CROSS=aarch64-linux-gnu-
                or
         make CROSS=aarch64-linux-gnu-
diff --git a/doc/guides/sample_app_ug/l3_forward_access_ctrl.rst b/doc/guides/sample_app_ug/l3_forward_access_ctrl.rst
index a44fbcd52c..ac23c3aa9c 100644
--- a/doc/guides/sample_app_ug/l3_forward_access_ctrl.rst
+++ b/doc/guides/sample_app_ug/l3_forward_access_ctrl.rst
@@ -184,7 +184,7 @@ Packet 2 matches Rule 2 and is forwarded to port 1.
 Packet 3 matches Rule 3 and is forwarded to port 0.
 
 For more details on the rule file format,
-please refer to rule_ipv4.db and rule_ipv6.db files (inside <RTE_SDK>/examples/l3fwd-acl/).
+please refer to rule_ipv4.db and rule_ipv6.db files (inside dpdk/examples/l3fwd-acl/).
 
 Application Phases
 ~~~~~~~~~~~~~~~~~~
diff --git a/doc/guides/sample_app_ug/performance_thread.rst b/doc/guides/sample_app_ug/performance_thread.rst
index b04d0ba444..7303ff19c4 100644
--- a/doc/guides/sample_app_ug/performance_thread.rst
+++ b/doc/guides/sample_app_ug/performance_thread.rst
@@ -1150,8 +1150,7 @@ To build and run the pthread shim example
 
    .. code-block:: console
 
-       export RTE_SDK=/path/to/rte_sdk
-       cd ${RTE_SDK}/examples/performance-thread/pthread_shim
+       cd dpdk/examples/performance-thread/pthread_shim
 
 
 #. Set the target (a default target is used if not specified). For example:
diff --git a/doc/guides/sample_app_ug/qos_scheduler.rst b/doc/guides/sample_app_ug/qos_scheduler.rst
index b5010657a7..5cd64b5fd4 100644
--- a/doc/guides/sample_app_ug/qos_scheduler.rst
+++ b/doc/guides/sample_app_ug/qos_scheduler.rst
@@ -42,7 +42,7 @@ The application is located in the ``qos_sched`` sub-directory.
 .. note::
 
     To get statistics on the sample app using the command line interface as described in the next section,
-    DPDK must be compiled defining *CONFIG_RTE_SCHED_COLLECT_STATS*,
+    DPDK must be compiled defining *RTE_SCHED_COLLECT_STATS*,
     which can be done by changing the configuration file for the specific target to be compiled.
 
 Running the Application
diff --git a/doc/guides/sample_app_ug/rxtx_callbacks.rst b/doc/guides/sample_app_ug/rxtx_callbacks.rst
index 0a69ec71ab..087744bd0b 100644
--- a/doc/guides/sample_app_ug/rxtx_callbacks.rst
+++ b/doc/guides/sample_app_ug/rxtx_callbacks.rst
@@ -25,13 +25,6 @@ To compile the sample application see :doc:`compiling`.
 
 The application is located in the ``rxtx_callbacks`` sub-directory.
 
-The callbacks feature requires that the ``CONFIG_RTE_ETHDEV_RXTX_CALLBACKS``
-setting is on in the ``config/common_`` config file that applies to the
-target. This is generally on by default:
-
-.. code-block:: console
-
-    CONFIG_RTE_ETHDEV_RXTX_CALLBACKS=y
 
 Running the Application
 -----------------------
diff --git a/doc/guides/sample_app_ug/service_cores.rst b/doc/guides/sample_app_ug/service_cores.rst
index cd0f4717aa..d2a2a6cac3 100644
--- a/doc/guides/sample_app_ug/service_cores.rst
+++ b/doc/guides/sample_app_ug/service_cores.rst
@@ -24,16 +24,7 @@ Compiling the Application
 
     .. code-block:: console
 
-        export RTE_SDK=/path/to/rte_sdk
-        cd ${RTE_SDK}/examples/service_cores
-
-#.  Set the target (a default target is used if not specified). For example:
-
-    .. code-block:: console
-
-        export RTE_TARGET=x86_64-native-linux-gcc
-
-    See the *DPDK Getting Started* Guide for possible RTE_TARGET values.
+        cd dpdk/examples/service_cores
 
 #.  Build the application:
 
diff --git a/doc/guides/sample_app_ug/tep_termination.rst b/doc/guides/sample_app_ug/tep_termination.rst
index df159355d6..a26fa888e7 100644
--- a/doc/guides/sample_app_ug/tep_termination.rst
+++ b/doc/guides/sample_app_ug/tep_termination.rst
@@ -90,18 +90,6 @@ The example in this section have been validated with the following distributions
 
 *   Fedora* 20
 
-Compiling the Sample Code
--------------------------
-
-To enable vhost, turn on vhost library in the configure file
-``config/common_linux``.
-
-    .. code-block:: console
-
-        CONFIG_RTE_LIBRTE_VHOST=y
-
-Then following the to compile the sample application shown in
-:doc:`compiling`.
 
 Running the Sample Code
 -----------------------
@@ -110,8 +98,7 @@ Running the Sample Code
 
     .. code-block:: console
 
-        export RTE_SDK=/path/to/rte_sdk
-        cd ${RTE_SDK}/examples/tep_termination
+        cd dpdk/examples/tep_termination
 
 #.  Run the tep_termination sample code:
 
diff --git a/doc/guides/sample_app_ug/test_pipeline.rst b/doc/guides/sample_app_ug/test_pipeline.rst
index 5aefd8d89f..a540faa3ed 100644
--- a/doc/guides/sample_app_ug/test_pipeline.rst
+++ b/doc/guides/sample_app_ug/test_pipeline.rst
@@ -32,7 +32,7 @@ Compiling the Application
 -------------------------
 To compile the sample application see :doc:`compiling`
 
-The application is located in the ``$RTE_SDK/app/test-pipeline`` directory.
+The application is located in the ``dpdk/app/test-pipeline`` directory.
 
 
 Running the Application
diff --git a/doc/guides/sample_app_ug/vhost.rst b/doc/guides/sample_app_ug/vhost.rst
index b7ed4f8bdf..ad682c68b2 100644
--- a/doc/guides/sample_app_ug/vhost.rst
+++ b/doc/guides/sample_app_ug/vhost.rst
@@ -78,7 +78,7 @@ could be done by:
 .. code-block:: console
 
    modprobe uio_pci_generic
-   $RTE_SDK/usertools/dpdk-devbind.py -b uio_pci_generic 0000:00:04.0
+   dpdk/usertools/dpdk-devbind.py -b uio_pci_generic 0000:00:04.0
 
 Then start testpmd for packet forwarding testing.
 
diff --git a/doc/guides/sample_app_ug/vm_power_management.rst b/doc/guides/sample_app_ug/vm_power_management.rst
index 1b6de8e936..d8d35d6d88 100644
--- a/doc/guides/sample_app_ug/vm_power_management.rst
+++ b/doc/guides/sample_app_ug/vm_power_management.rst
@@ -245,26 +245,23 @@ To build just the ``vm_power_manager`` application using ``make``:
 
 .. code-block:: console
 
-   export RTE_SDK=/path/to/rte_sdk
-   export RTE_TARGET=build
-   cd ${RTE_SDK}/examples/vm_power_manager/
+   cd dpdk/examples/vm_power_manager/
    make
 
-The resulting binary is ``${RTE_SDK}/build/examples/vm_power_manager``.
+The resulting binary is ``dpdk/build/examples/vm_power_manager``.
 
 To build just the ``vm_power_manager`` application using ``meson``/``ninja``:
 
 .. code-block:: console
 
-   export RTE_SDK=/path/to/rte_sdk
-   cd ${RTE_SDK}
+   cd dpdk
    meson build
    cd build
    ninja
    meson configure -Dexamples=vm_power_manager
    ninja
 
-The resulting binary is ``${RTE_SDK}/build/examples/dpdk-vm_power_manager``.
+The resulting binary is ``dpdk/build/examples/dpdk-vm_power_manager``.
 
 Running the Host Application
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -462,12 +459,10 @@ the following commands:
 
 .. code-block:: console
 
-   export RTE_SDK=/path/to/rte_sdk
-   export RTE_TARGET=build
-   cd ${RTE_SDK}/examples/vm_power_manager/guest_cli/
+   cd dpdk/examples/vm_power_manager/guest_cli/
    make
 
-The resulting binary is ``${RTE_SDK}/build/examples/guest_cli``.
+The resulting binary is ``dpdk/build/examples/guest_cli``.
 
 **Note**: This sample application conditionally links in the Jansson JSON
 library. Consequently, if you are using a multilib or cross-compile
@@ -498,15 +493,14 @@ To build just the ``vm_power_manager`` application using ``meson``/``ninja``:
 
 .. code-block:: console
 
-   export RTE_SDK=/path/to/rte_sdk
-   cd ${RTE_SDK}
+   cd dpdk
    meson build
    cd build
    ninja
    meson configure -Dexamples=vm_power_manager/guest_cli
    ninja
 
-The resulting binary is ``${RTE_SDK}/build/examples/guest_cli``.
+The resulting binary is ``dpdk/build/examples/guest_cli``.
 
 Running the Guest Application
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
diff --git a/doc/guides/sample_app_ug/vmdq_dcb_forwarding.rst b/doc/guides/sample_app_ug/vmdq_dcb_forwarding.rst
index 8e1774d9e2..c66877c538 100644
--- a/doc/guides/sample_app_ug/vmdq_dcb_forwarding.rst
+++ b/doc/guides/sample_app_ug/vmdq_dcb_forwarding.rst
@@ -26,8 +26,8 @@ multiple queues. When run with 8 threads, that is, with the -c FF option, each t
 As supplied, the sample application configures the VMDQ feature to have 32 pools with 4 queues each as indicated in :numref:`figure_vmdq_dcb_example`.
 The Intel® 82599 10 Gigabit Ethernet Controller NIC also supports the splitting of traffic into 16 pools of 8 queues. While the
 Intel® X710 or XL710 Ethernet Controller NICs support many configurations of VMDQ pools of 4 or 8 queues each. For simplicity, only 16
-or 32 pools is supported in this sample. And queues numbers for each VMDQ pool can be changed by setting CONFIG_RTE_LIBRTE_I40E_QUEUE_NUM_PER_VM
-in config/common_* file.
+or 32 pools is supported in this sample. And queues numbers for each VMDQ pool can be changed by setting RTE_LIBRTE_I40E_QUEUE_NUM_PER_VM
+in config/rte_config.h file.
 The nb-pools, nb-tcs and enable-rss parameters can be passed on the command line, after the EAL parameters:
 
 .. code-block:: console
diff --git a/doc/guides/sample_app_ug/vmdq_forwarding.rst b/doc/guides/sample_app_ug/vmdq_forwarding.rst
index c3a3439e51..5df6bbeef3 100644
--- a/doc/guides/sample_app_ug/vmdq_forwarding.rst
+++ b/doc/guides/sample_app_ug/vmdq_forwarding.rst
@@ -24,8 +24,8 @@ multiple queues. When run with 8 threads, that is, with the -c FF option, each t
 As supplied, the sample application configures the VMDq feature to have 32 pools with 4 queues each.
 The Intel® 82599 10 Gigabit Ethernet Controller NIC also supports the splitting of traffic into 16 pools of 2 queues.
 While the Intel® X710 or XL710 Ethernet Controller NICs support many configurations of VMDq pools of 4 or 8 queues each.
-And queues numbers for each VMDq pool can be changed by setting CONFIG_RTE_LIBRTE_I40E_QUEUE_NUM_PER_VM
-in config/common_* file.
+And queues numbers for each VMDq pool can be changed by setting RTE_LIBRTE_I40E_QUEUE_NUM_PER_VM
+in config/rte_config.h file.
 The nb-pools and enable-rss parameters can be passed on the command line, after the EAL parameters:
 
 .. code-block:: console