diff --git a/doc/guides/platform/bluefield.rst b/doc/guides/platform/bluefield.rst
index deda675b75..366f2b23a7 100644
--- a/doc/guides/platform/bluefield.rst
+++ b/doc/guides/platform/bluefield.rst
@@ -60,17 +60,6 @@ Native Compilation
 Refer to :doc:`../nics/mlx5` for prerequisites. Either Mellanox OFED/EN or
 rdma-core library with corresponding kernel drivers is required.
 
-make build
-^^^^^^^^^^
-
-.. code-block:: console
-
-        make config T=arm64-bluefield-linux-gcc
-        make -j
-
-meson build
-^^^^^^^^^^^
-
 .. code-block:: console
 
         meson build
@@ -126,17 +115,6 @@ Then, untar the tarball at the cross toolchain directory on the x86 host.
         cd $(dirname $(which aarch64-linux-gnu-gcc))/..
         tar xf aarch64-linux-gnu-mlx.tar
 
-make build
-^^^^^^^^^^
-
-.. code-block:: console
-
-        make config T=arm64-bluefield-linux-gcc
-        make -j CROSS=aarch64-linux-gnu- CONFIG_RTE_KNI_KMOD=n CONFIG_RTE_EAL_IGB_UIO=n
-
-meson build
-^^^^^^^^^^^
-
 .. code-block:: console
 
         meson build --cross-file config/arm/arm64_bluefield_linux_gcc
diff --git a/doc/guides/platform/octeontx.rst b/doc/guides/platform/octeontx.rst
index 7d1cb647d3..9c20ce437d 100644
--- a/doc/guides/platform/octeontx.rst
+++ b/doc/guides/platform/octeontx.rst
@@ -90,23 +90,8 @@ native architecture, the linux sources need to be compiled once natively.
 
 The above steps would rebuild the modules and the required intermediate binaries.
 Once the target is ready for native compilation, the OCTEON TX platform
-drivers can be compiled with the following steps,
+drivers can be compiled, see :doc:`../linux_gsg/build_dpdk` for details.
 
-.. code-block:: console
-
-        cd <dpdk directory>
-        make config T=arm64-thunderx-linux-gcc
-        make
-
-The example applications can be compiled using the following:
-
-.. code-block:: console
-
-        cd <dpdk directory>
-        export RTE_SDK=$PWD
-        export RTE_TARGET=build
-        cd examples/<application>
-        make
 
 Cross Compilation
 ~~~~~~~~~~~~~~~~~
@@ -139,23 +124,7 @@ SDK 6.2.0 patch 3:
 The above steps will prepare build system with numa additions. Now this build system can be used
 to build applications for **OCTEON TX** :sup:`®` platforms.
 
-.. code-block:: console
-
-        cd <dpdk directory>
-        export RTE_SDK=$PWD
-        export RTE_KERNELDIR=$THUNDER_ROOT/linux/kernel/linux
-        make config T=arm64-thunderx-linux-gcc
-        make -j CROSS=aarch64-thunderx-linux-gnu- CONFIG_RTE_KNI_KMOD=n CONFIG_RTE_EAL_IGB_UIO=n EXTRA_CFLAGS="-isystem <numa_install_dir>/include" EXTRA_LDFLAGS="-L<numa_install_dir>/lib -lnuma"
-
 If NUMA support is not required, it can be disabled as explained in
 :doc:`../linux_gsg/cross_build_dpdk_for_arm64`.
 
-Following steps could be used in that case.
-
-.. code-block:: console
-
-        make config T=arm64-thunderx-linux-gcc
-        make CROSS=aarch64-thunderx-linux-gnu-
-
-
 SDK and related information can be obtained from: `Cavium support site <https://support.cavium.com/>`_.
diff --git a/doc/guides/platform/octeontx2.rst b/doc/guides/platform/octeontx2.rst
index 13255eec5c..232f628366 100644
--- a/doc/guides/platform/octeontx2.rst
+++ b/doc/guides/platform/octeontx2.rst
@@ -498,27 +498,6 @@ an x86 based platform.
 Native Compilation
 ~~~~~~~~~~~~~~~~~~
 
-make build
-^^^^^^^^^^
-
-.. code-block:: console
-
-        make config T=arm64-octeontx2-linux-gcc
-        make -j
-
-The example applications can be compiled using the following:
-
-.. code-block:: console
-
-        cd <dpdk directory>
-        export RTE_SDK=$PWD
-        export RTE_TARGET=build
-        cd examples/<application>
-        make -j
-
-meson build
-^^^^^^^^^^^
-
 .. code-block:: console
 
         meson build
@@ -529,17 +508,6 @@ Cross Compilation
 
 Refer to :doc:`../linux_gsg/cross_build_dpdk_for_arm64` for generic arm64 details.
 
-make build
-^^^^^^^^^^
-
-.. code-block:: console
-
-        make config T=arm64-octeontx2-linux-gcc
-        make -j CROSS=aarch64-marvell-linux-gnu- CONFIG_RTE_KNI_KMOD=n
-
-meson build
-^^^^^^^^^^^
-
 .. code-block:: console
 
         meson build --cross-file config/arm/arm64_octeontx2_linux_gcc